; NULL 終端文字列表示.
; 引数: ds:ax=表示対象文字列.
; 戻値: 無し.
; 破壊: al
putstr PROC
	push	si
	mov	si, ax
Lloop:	mov	al, [si]
	test	al, al
	jz	Lend
	int	29h
	inc	si
	jmp	Lloop
Lend:	pop	si
	ret
putstr ENDP
; 文字列表示マクロ.
PUTS MACRO msg:REQ
	mov	ax, offset msg
	call	putstr
ENDM

; al の数値を16進数2桁で表示.
; 引数: al=表示対象数値.
; 戻値: 無し.
; 破壊: ax
print_al_hex PROC
	mov	ah, al		; save al
	shr	al, 4
.if (al <= 9)
	add	al, '0'
.else
	add	al, 'a' - 0ah
.endif
	int	29h
	;---
	mov	al, ah
	and	al, 0fh
.if (al <= 9)
	add	al, '0'
.else
	add	al, 'a' - 0ah
.endif
	int	29h
	;---
	ret
print_al_hex ENDP


; EMS ドライバ存在確認.
; 引数: 無し.
; 戻値: CF=確認結果(0: 存在している, 1: 存在しない)
; 破壊: ax
check_ems_driver PROC
	push	es
	push	bx
	mov	ah, 40h
	int	67h
	test	ah, ah
	jnz	Lstc
	clc
@@:	pop	bx
	pop	es
	ret
Lstc:	stc
	jmp	@B
check_ems_driver ENDP


; VCPI 存在確認.
; 引数: 無し.
; 戻値: CF=確認結果(0: 存在している, 1: 存在しない)
; 破壊: ax
check_vcpi PROC
	push	bx
	mov	ax, 0de00h
	int	67h
	pop	bx
.if(ah)
	stc
.else
	clc
.endif
	ret
check_vcpi ENDP


; リニアアドレス計算.
; 引数: dx:ax=segment:offset
; 戻値: eax=linear addr
; 破壊: 無し.
calc_linear_addr PROC
	push	edx
	and	edx, 0ffffh
	and	eax, 0ffffh
	shl	edx, 4
	add	eax, edx
	pop	edx
	ret
calc_linear_addr ENDP


; セグメントディスクリプタの base 設定.
; 引数: dx:ax=base addr(segment:offset の形式), ds:bx=addr of segdesc
; 戻値: 無し.
; 破壊: eax, edx(上位 16bit)
set_segdesc_base PROC
	push	dx
	assume	bx:ptr SEGDESC
	;---
	and	edx, 0ffffh
	and	eax, 0ffffh
	shl	edx, 4		; edx=linear addr of segment
	add	eax, edx	; eax=linear addr of dx:ax
	mov	[bx].base_l, ax
	shr	eax, 16
	mov	[bx].base_h, al
	mov	[bx].base_hh, ah
	;---
	assume	bx:nothing
	pop	dx
	ret
set_segdesc_base ENDP
